(*Copyright (C) 2004 Jean-Baptiste Rouquier, see main.ml*)

(* #load "str.cma" *)
(* open Str *)

let echg mot i j =
  let temp = mot.[i] in
  mot.[i] <- mot.[j];
  mot.[j] <- temp

let shuffle_mot mot =
  for i=2 to String.length mot -2 do echg mot i (Random.int i +1) done

(* test: *)
(* let rec count = function *)
(*   | a::b::q -> *)
(*       if a <> b then (a,1) :: count (b::q) *)
(*       else *)
(* 	let (b, nb) :: l = count (b::q) in *)
(* 	(b,nb+1) :: l *)
(*   | a::[] -> [a,1] *)
(*   | [] -> [] *)

(* let _ = count [1;1;2;3;3;3;3;4;5;6;6;] *)

(* let _ = *)
(*   let a = Array.init 10000 *)
(*    (fun _ -> *)
(*       let a = String.copy "abcdae" *)
(*       in shuffle_mot a; a) in *)
(*   Array.sort compare a; *)
(*   let l = Array.to_list a in *)
(*   count l *)

let split_mots s =
  let wb = Str.regexp "\\b" in (*word boundary*)
  let len = String.length s in
  let mange_un_mot debut = (*[debut] est la 1re lettre d'un mot*)
    let fin = Str.search_forward wb s (debut +1) in
    let mot = String.sub s debut (fin - debut) in
    let debut_suivant =
      try
	if fin+1 >= len then raise Not_found;
	Str.search_forward wb s (fin+1)
      with Not_found -> len in
    let non_mot = String.sub s fin (debut_suivant - fin) in
    mot, non_mot, debut_suivant in
  let rec loop result pos =
    if pos >= len then List.rev result else
      let mot, non_mot, pos = mange_un_mot pos in
      loop ((mot,non_mot) :: result) pos in
(*   if s = "" then "",[] *)
(*   else *)
  try
    let debut = Str.search_forward wb s 0 in (* may raise Not_found *)
    String.sub s 0 debut, loop [] debut
  with Not_found -> "",[]

(* test: *)
(* let _ = split_mots "a bc def  g a g" *)
(* let _ = split_mots " foo bar " *)
(* let _ = split_mots "  foo;bar  " *)
(* let _ = split_mots ",?;.:/!foo'()bar-_@baz=+" *)
